(function() {
	/************************************************************************
	 * WebSocket
	 * Android4.3以下のWebViewではWebSocketを使用できない点を補うために、
	 * アプリ側でWebSocketを実装した機能。iOS、PCでこのAPIを使用した場合は、
	 * applican.jsの内部でブラウザ標準のWebSocketを使用するように設定している
	 ************************************************************************/

	/*
	 * サーバへ接続
	 */
	openWebSocket = function() {
		applican.webSocket.open("ws://echo.websocket.org",
			webSocketOnOpen,
			webSocketOnMessage,
			webSocketOnClose,
			webSocketOnError
		);
	};

	/*
	 * サーバとの接続完了時のコールバック
	 */
	webSocketOnOpen = function() {
		var dump = "webSocketOnOpen\n";
		document.getElementById("dumpAreaWebSocket").value = dump;
	};
	/*
	 * メッセージ受信時のコールバック
	 */
	webSocketOnMessage = function(event) {
		var dump = "webSocketOnMessage\n";
		dump += event.data + "\n";
		document.getElementById("dumpAreaWebSocket").value = dump;
	};
	/*
	 * サーバとの切断時のコールバック
	 */
	webSocketOnClose = function() {
		var dump = "webSocketOnClose\n";
		document.getElementById("dumpAreaWebSocket").value = dump;
	};
	/*
	 * エラー発生時のコールバック
	 */
	webSocketOnError = function(event) {
		var dump = "webSocketOnError\n";
		dump += event.data + "\n";
		document.getElementById("dumpAreaWebSocket").value = dump;
	};

	/*
	 * メッセージを送信
	 */
	sendWebSocket = function() {
		var data = "TEST_MESSAGE";
		applican.webSocket.send(data);
	};

	/*
	 * サーバから切断
	 */
	closeWebSocket = function() {
		applican.webSocket.close();
	};

	/*
	 * 画面初期表示処理
	 */
	document.addEventListener("readystatechange", function() {
			if (document.readyState == "complete") {
				//「open」ボタン押下時の処理
				document.getElementById("openWebSocketButton").addEventListener("click", function() {
					openWebSocket(false);
					return false;
				}, false);
				//「メッセージ送信」ボタン押下時の処理
				document.getElementById("sendWebSocketButton").addEventListener("click", function() {
					sendWebSocket(false);
					return false;
				}, false);
				//「close」ボタン押下時の処理
				document.getElementById("closeWebSocketButton").addEventListener("click", function() {
					closeWebSocket(false);
					return false;
				}, false);
			}
		}
	);
})();
